//	bfe2 - control buttons
//	Copyright (c) 1999-2003 Brand Huntsman and Lee Salzman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global
uint32 steplock_time, nextlock_time;

// local

//////////////////////////////////////////////////////////////////////////


void instr_go( ){
	bochs_running = 1;

	set_ctrl_running(TRUE);

	fprintf(writepipe, "c\n");
	fgetc(readpipe);
	hook_sigio();

	historyWrite("GO...");
}


void instr_stop( int sigio ){
	char buffer[200];
	int bp, bpn, n;

	unhook_sigio();
	bochs_running = 0;

	if(!sigio){
		// send ctrl-c to bochs to break out of 'Continue'
		kill(bochs_pid, SIGINT);
	} else {
		// read breakpoint info
		fgets(buffer, 200, readpipe);
		if(sscanf(buffer, "%*s %*s %i, %*s %*s", &bp) == 0){
			if(tracing){
				// tracing is on
				n = 1;
				sscanf(&buffer[n], "%*s %x:%x: ", &i_virtual_segment, &i_virtual_offset);
				n = remove_word(buffer, n, 200); n = remove_word(buffer, n, 200);
				if(buffer[n] == '('){
					n = remove_word(buffer, n, 200); n = remove_word(buffer, n, 200);
				}
				sscanf(&buffer[n], "%*x%n: ", &i_size);
				i_size/=2;
				n = remove_word(buffer, n, 200);
				string_read(&buffer[n], i_description, '\n');
				historyUpdate();
				bochs_running = 1;
				hook_sigio();
				return;
			} else {
				// dont know what happened here
			}
		}
		if(!next_active){
			breakpointsUpdate(1);
			for(bpn = 0; bp != breakpoints[bpn].number; bpn++);
			breakpointsSelect(bpn);
		}
	}

	update_bfe();

	if(next_active){
		// delete breakpoint that was used by the NEXT button
		fprintf(writepipe, "d %d\n", bp);
		prompt_read();
		next_active = 0;
	}

	set_ctrl_running(FALSE);
}


void instr_step( ){
	fprintf(writepipe, "s\n");
	update_bfe();
}


void instr_next( ){
	if(i_description[0] == 'j' || (i_description[0] == 'l' && i_description[2] == 's' && i_description[3] == ' ')){
		instr_step();
		return;
	}

	fprintf(writepipe, "vb 0x%X:0x%X\n", i_virtual_segment, i_virtual_offset + i_size);
	#ifdef __DEBUG__
	 g_print("BFE DEBUG: (NEXT) vb 0x%X:0x%X\n", i_virtual_segment, i_virtual_offset + i_size);
	#endif
	prompt_read();

	next_active = 1;
	bochs_running = 1;

	set_ctrl_running(TRUE);

	fprintf(writepipe, "c\n");

	// __OLD_BOCHS__
	// fgetc(readpipe);

	hook_sigio();

	historyWrite("NEXT...");
}
