//	bfe2 - functions prototypes
//	Copyright (c) 1999-2003 Brand Huntsman and Lee Salzman
//


//
// main.c
//

void	bfe_quit	( );


//
// misc.c
//

int	get_physical	( long segment, uint32 offset , uint32 *physical );
void	update_bfe	( );
int	string_read	( char *buffer, char *string, const char delimiter );
int	remove_word	( char *buffer, int current, int max );

GtkWidget *	new_hbox	( GtkWidget *box, gboolean pack );
GtkWidget *	new_vbox	( GtkWidget *box, gboolean pack );
void		new_gap		( GtkWidget *box );

void	set_ctrl_online		( gboolean v );
void	set_ctrl_running	( gboolean v );


//
// bochs.c
//

void	hook_sigio	( );
void	unhook_sigio	( );

void	bochsInit	( );
void	bochsShutdown	( );
void	bochsStart	( );
void	bochsRestart	( );

int	prompt_read	( );


//
// control.c
//

void	instr_go	( );
void	instr_stop	( int sigio );
void	instr_step	( );
void	instr_next	( );


//
// state.c
//

void	stateInit		( GtkWidget *hbox );

void	stateUpdate		( );
void	stateUpdateStack	( );

int	read_cpu		( );


//
// breakpoints.c
//

void	breakpointsInit		( GtkWidget *vbox );
void	breakpointsUpdate	( int redraw );
void	breakpointsEnablePage	( gboolean v );
void	breakpointsSelect	( int bp );


//
// watchpoints.c
//

void	watchpointsInit		( GtkWidget *vbox );
void	watchpointsUpdate	( int redraw );
void	watchpointsEnablePage	( gboolean v );
void	watchpointsSelect	( int wp );


//
// memory.c
//

void	memoryInit		( GtkWidget *vbox );
void	memoryUpdate		( );
void	memoryUpdateWindow	( long tmp );
void	memoryEnablePage	( gboolean v );


//
// structures.c
//

void	structuresInit		( GtkWidget *vbox );
void	structuresUpdate	( );
void	structuresUpdateWindow	( int s );
void	structuresEnablePage	( gboolean v );


//
// config.c
//

void	configInit		( GtkWidget *vbox );
void	configUpdate		( );
void	configEnablePage	( gboolean v );


//
// history.c
//

void	historyInit		( GtkWidget *vbox );
void	historyClose		( );
void	historyClear		( GtkWidget *widget, gpointer data );
void	historyUpdate		( );
void	historyRepeat		( );
void	historyWrite		( char *message );
void	historyClip		( );

