//	bfe2 - structure dump
//	Copyright (c) 1999-2003 Brand Huntsman and Lee Salzman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global
s_mem *memlist;
int nr_strucs;

// local
GtkCList *s_list;

//////////////////////////////////////////////////////////////////////////


/*
void show_structure( FL_OBJECT *obj, long argument ){
	char temp[200];
	int s;

	s = fl_get_browser(st_list) - 1;

	if(memlist[s].window == NULL){
		memlist[s].window = fl_bgn_form(FL_FLAT_BOX, 400, 300);

		memlist[s].table = fl_add_browser(FL_HOLD_BROWSER,            5,   5, 390, 264, NULL);
		fl_set_object_lstyle(memlist[s].table, FL_FIXED_STYLE);
		fl_set_object_gravity(memlist[s].table, FL_NorthWest, FL_SouthEast);
		fl_set_object_resize(memlist[s].table, FL_RESIZE_ALL);



		memlist[s].start_text = fl_add_input(FL_NORMAL_INPUT,   35, 270,  50,  25, "Start");
		fl_set_input_maxchars(memlist[s].start_text, 8);
		fl_set_object_lstyle(memlist[s].start_text, FL_BOLD_STYLE);
		fl_set_object_gravity(memlist[s].start_text, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(memlist[s].start_text, FL_RESIZE_NONE);
		fl_set_input(memlist[s].start_text, "0");

		memlist[s].total_text = fl_add_input(FL_NORMAL_INPUT,   135, 270,  50,  25, "Total");
		fl_set_input_maxchars(memlist[s].total_text, 8);
		fl_set_object_lstyle(memlist[s].total_text, FL_BOLD_STYLE);
		fl_set_object_gravity(memlist[s].total_text, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(memlist[s].total_text, FL_RESIZE_NONE);
		fl_set_input(memlist[s].total_text, "100");
		fl_set_input_return(memlist[s].total_text, FL_RETURN_END);
		fl_set_object_callback(memlist[s].total_text, refresh_structure, s);

		memlist[s].refresh_button = fl_add_button(FL_NORMAL_BUTTON,   290, 270,  50,  25, "Refresh");
		fl_set_object_lstyle(memlist[s].refresh_button, FL_BOLD_STYLE);
		fl_set_object_callback(memlist[s].refresh_button, refresh_structure, s);
		fl_set_object_gravity(memlist[s].refresh_button, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(memlist[s].refresh_button, FL_RESIZE_NONE);

		memlist[s].close_button = fl_add_button(FL_NORMAL_BUTTON,   345, 270,  50,  25, "Close");
		fl_set_object_lstyle(memlist[s].close_button, FL_BOLD_STYLE);
		fl_set_object_callback(memlist[s].close_button, close_structure, s);
		fl_set_object_gravity(memlist[s].close_button, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(memlist[s].close_button, FL_RESIZE_NONE);

		fl_end_form();
	}
	snprintf(temp, 200, "BFE - Structure - %s", memlist[s].name);
	fl_show_form(memlist[s].window, FL_PLACE_MOUSE|FL_FREE_SIZE, FL_FULLBORDER, temp_string);
	structureUpdate(s);
}


void close_structure( FL_OBJECT *obj, long argument ){
	fl_hide_form(memlist[argument].window);
}


void refresh_structure( FL_OBJECT *obj, long argument ){
	if(bochs_running){
		fl_ringbell(0);
		return;
	}
	structureUpdate((int)argument);
}
*/


//////////////////////////////////////////////////////////////////////////


void structuresInit( GtkWidget *vbox ){
}


void structuresUpdate( ){
/*
	int x;

	for(x=0; x < nr_strucs; x++){
		snprintf(temp, 200, "@bbase=0x%.8X\telements=%d\tvalues=%d\tname=\"%s\"",
			memlist[x].base, memlist[x].element_count, memlist[x].value_count, memlist[x].name);
		fl_add_browser_line(st_list, temp);
		memlist[x].window = NULL;            
	}
	mem_windows = NULL;
*/
}


void structuresUpdateWindow( int s ){
/*
	char string[200], nr_string[10];
	int x, y, size, offset;
	uint32 val, val1;
	int start, total;

	if(bochs_offline) return;

	if(memlist[s].window == NULL) return;
	size = 0;
	fl_freeze_form(memlist[s].window);
	fl_clear_browser(memlist[s].table);

	start = atoi(fl_get_input(memlist[s].start_text));
	total = atoi(fl_get_input(memlist[s].total_text));

	if(total<0 || total>memlist[s].element_count){
		total=memlist[s].element_count;
		snprintf(nr_string, 10, "%d", total);
		fl_set_input(memlist[s].total_text, nr_string);
	}
	if(start<0 || start>=memlist[s].element_count){
		start=0;
		fl_set_input(memlist[s].start_text, "0");
	}
	if(total+start>memlist[s].element_count){
		total=memlist[s].element_count-start;
		snprintf(nr_string, 10, "%d", total);
		fl_set_input(memlist[s].total_text, nr_string);
	}

	for(y=0; y < memlist[s].value_count; y++) size += memlist[s].values[y].size;

	for(x=start; x < start+total; x++){
		offset = 0;
		snprintf(string, 200, "@b0x%.8X (%d)", memlist[s].base+(x*size), x);
		fl_add_browser_line(memlist[s].table, string);
		for(y=0; y < memlist[s].value_count; y++){
		   if(memlist[s].values[y].name[0] == '\\' && memlist[s].values[y].name[1] == '\\'){
			string[0] = '\0';
			fl_add_browser_line(memlist[s].table, string);
		   } else {
			switch(memlist[s].values[y].size){
			case 1:
				fprintf(writepipe, "x /1bx 0x%X\n", memlist[s].base+(x*size)+offset);
				fscanf(readpipe, " %*s %*s 0x%X ", &val);
				snprintf(string, 200, "\tBYTE  %s = 0x%.2X", memlist[s].values[y].name, val);
				break;
			case 2:
				fprintf(writepipe, "x /1hx 0x%X\n", memlist[s].base+(x*size)+offset);
				fscanf(readpipe, " %*s %*s 0x%X ", &val);
				snprintf(string, 200, "\tWORD  %s = 0x%.4X", memlist[s].values[y].name, val);
				break;
			case 4:
				fprintf(writepipe, "x /1wx 0x%X\n", memlist[s].base+(x*size)+offset);
				fscanf(readpipe, " %*s %*s 0x%X ", &val);
				snprintf(string, 200, "\tDWORD  %s = 0x%.8X", memlist[s].values[y].name, val);
				break;
			case 8:
				fprintf(writepipe, "x /2wx 0x%X\n", memlist[s].base+(x*size)+offset);
				fscanf(readpipe, " %*s %*s 0x%X 0x%X", &val, &val1);
				snprintf(string, 200, "\tQWORD  %s = 0x%.8X%.8X", memlist[s].values[y].name, val1, val);
				break;
			default:
				g_print("BFE: encountered a structure value with a non power of 2 size, or a size larger than 8 bytes.\n");
			}

			prompt_read();
			offset += memlist[s].values[y].size;
			fl_add_browser_line(memlist[s].table, string);
		   }
		}
	}
	fl_unfreeze_form(memlist[s].window);
*/
}


void structuresEnablePage( gboolean v ){
	gtk_widget_set_sensitive(GTK_WIDGET(s_list), v);
}
